<template>
  <form
    id="dsnFileUploadForm"
    novalidate="novalidate"
  >
    <div class="form-group">
      <label for="upload">Fichier(s) DSN</label>
      <el-upload
        id="upload"
        ref="upload"
        class="upload-dsnfiles"
        drag
        action="api/checkfile"
        :file-list="fileList"
        :data="uploadData"
        multiple
      >
        <i class="el-icon-upload" />
        <div class="el-upload__text">
          Déposer les fichiers ici ou <em>cliquez pour envoyer</em>
          <br>
          <br>
        </div>
        <div
          slot="tip"
          class="el-upload__tip"
        >
          Fichiers txt/edi/dsn avec une taille cumulée inférieure à 150Mo dans la limite de 20 fichiers
        </div>
      </el-upload>
      <br>
      <el-checkbox v-model="isAnonymized">
        Anonymiser les données
      </el-checkbox>
      <br>
      <el-button
        size="small"
        type="primary"
        @click="processFiles()"
      >
        Envoyer
      </el-button>
    </div>
  </form>
</template>

<script>
import { mapGetters, mapActions } from 'vuex'
import VanillaToasts from 'vanillatoasts'

export default {
  name: "FilesUploadForm",
  components: {},
  data() {
    return {
      validator: null,
      upload: null,
      fileList: [],
      uploadData: null,
      dsnFilesLength: 0,
      dsnFileAndIndex: null,
      isAnonymized: false
    }
  },
  computed: {
    ...mapGetters([
      'isLoading',
      'wizard',
      'hasError'
    ]),
  },
  mounted() {
    this.validator = $('#dsnFileUploadForm').submit(function(e) {
      e.preventDefault()
    })
  },
  methods: {
    ...mapActions([
      'sendFiles',
      'loadingStarts',
      'loadingEnds',
    ]),
    processFiles() {
      let totalFilesSize = 0;
      if(this.$refs.upload.uploadFiles.length>20) {
        VanillaToasts.create({
          title: 'Transmission de fichier(s)',
          text: 'Nombre limite de fichier atteint 20',
          type: 'error',
          timeout: 5000,
        });
      }
      this.$refs.upload.uploadFiles.forEach((file) => {
        totalFilesSize+=file.size
      })
      if(totalFilesSize > 150000000) {
        VanillaToasts.create({
          title: 'Transmission de fichier(s)',
          text: 'Taille limite atteinte 150 Mo',
          type: 'error',
          timeout: 5000,
        });
      }
      let formData = new FormData();
      if(this.$refs.upload.uploadFiles!==null) {
        if(this.$refs.upload.uploadFiles.length!==0) {
          this.loadingStarts()
          for (var i = 0; i < this.$refs.upload.uploadFiles.length; i++) {
            let file = this.$refs.upload.uploadFiles[i]

            formData.append('files[' + i + ']', file.raw)
            formData.append('isAnonymized', this.isAnonymized)
          }
          this.sendFiles(formData)
            .then(()=>{
              this.$refs.upload.clearFiles()
              if(!this.hasError) {
                VanillaToasts.create({
                  title: 'Transmission de fichier(s)',
                  text: 'Opération effectuée avec succès',
                  type: 'success',
                  timeout: 5000,
                });
                if(this.wizard.isFirstDsnFileAddedAndStatusOk===false) {
                  this.$emit('showWaitingPopup')
                }
              }
              this.loadingEnds()
            })
            .catch(()=>{
              this.$refs.upload.clearFiles()
              this.loadingEnds()
            })
        }
      }
    }
  }
}
</script>

<style>
.el-upload .el-upload__input {
  display: none !important;
}
.el-button {
  color: #e65245;
  background-color: #ffffff;
  border-color: #e65245;
  background-image: none;
}
.el-button:hover, .el-button:active, .el-button:focus {
  color: #ffffff;
  background-color: #e65245;
  border-color: #e65245;
}
</style>